﻿// <summary>ソースコード：ファクトリクラス</summary>
// <author>CommonMP</author>

using System;
using System.Collections.Generic;
using System.Text;

using CommonMP.HYSSOP.Interface.HSData;
using CommonMP.HYSSOP.Interface.HSViewer;
using CommonMP.HYSSOP.CoreImpl.HSData;
using CommonMP.HYSSOP.CoreImpl.HSTools;

using CommonMP.HYMCO.Interface;
using CommonMP.HYMCO.Interface.Model;
using CommonMP.HYMCO.Interface.Data;
using CommonMP.HYMCO.Interface.Controller;

using CommonMP.HYSSOP.CoreImpl;
using CommonMP.HYMCO.CoreImpl.Model;
using CommonMP.HYMCO.CoreImpl.Data;

using CommonMP.HYMCO._SYSTEM_;
namespace CommonMP.HYMCO._SYSTEM_
{
    /// <summary><para>class outline:</para>
    /// <para>HYMCOモデルファクトリ生成</para>
    /// </summary>
    /// <remarks><para>history:</para>
    /// <para>[CommonMP][ver 1.0.0][2009/10/01][新規作成]</para>
    /// </remarks>
    public class HYMCO_MODEL_FACTORY_CREATOR_IMPLE : HYMCO_MODEL_FACTORY_CREATOR
    {
        /// <summary><para>method outline:</para>
        /// <para>コンストラクター</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> HYMCO_MODEL_FACTORY_CREATOR_IMPLE csFactCrt = new HYMCO_MODEL_FACTORY_CREATOR_IMPLE( ) </para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>生成インスタンス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public HYMCO_MODEL_FACTORY_CREATOR_IMPLE()
        {
        }
        /// <summary><para>method outline:</para>
        /// <para>演算モデルファクトリクラス生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McModelFactory csCalModelFactory = CreateFactory( ) </para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>演算モデルファクトリクラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public CommonMP.HYMCO.Interface.Model.McModelFactory CreateFactory()
        {
            return new jp.or.jccajsce.MuskingumModel.MuskingumModelFactory();
        }
    }
}


namespace jp.or.jccajsce.MuskingumModel
{
    /// <summary><para>class outline:</para>
    /// <para>タンクモデルファクトリクラス</para>
    /// </summary>
    /// <remarks><para>history:</para>
    /// <para>[CommonMP][ver 1.0.0][2008/10/01][新規作成]</para>
    /// </remarks>
    public class MuskingumModelFactory : McBasicModelFactoryBase
    {
        /// <summary><para>method outline:</para>
        /// <para>ファクトリ識別子を生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> HySID csFactID = CreateFactoryID( ) </para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>ファクトリ識別子</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override HySID CreateFactoryID()
        {
            return MuskingumModelDefine.M_LIB;
        }

        /// <summary><para>method outline:</para>
        /// <para>演算モデルクラス生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McCalModel csCalModel = CreateCalModel(csModelKind) </para>
        /// </example>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>演算モデルクラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McCalModel CreateCalModel(HySObjectKind csModelKind)
        {
            McCalModel csCalModel = null;

            if (csModelKind.Equals(MuskingumModelDefine.M_KIND) == true)
            {
                csCalModel = new MuskingumModel();
            }
            else
            {
                // Do Nothing
            }

            return csCalModel;
        }

        /// <summary><para>method outline:</para>
        /// <para>要素内演算中データクラス生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McCalInfo csCalModel = CreateCalInfo( csModelKind ) </para>
        /// </example>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>要素内演算中データクラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McCalInfo CreateCalInfo(HySObjectKind csModelKind)
        {
            McCalInfo csCalInfoData = null;

            if (csModelKind.Equals(MuskingumModelDefine.M_KIND) == true)
            {
                csCalInfoData = new MuskingumModelCalInfo();
            }
            else
            {
                // Do Nothing
            }

            return csCalInfoData;
        }

        /// <summary><para>method outline:</para>
        /// <para>モデルプロパティ表示／設定情報クラス生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McPropertyInfoRoot csPropertyInf = CreateModelPropertyInfo(csLibraryID, csModelKind ) </para>
        /// </example>
        /// <param name="csLibraryID">ライブラリー識別子</param>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>モデルプロパティ表示／設定情報クラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McCellModelPropertyIF CreateModelProperty(HySID csLibraryID, HySObjectKind csModelKind)
        {
            if (this.EqualFactory(csLibraryID) == false)
            {
                return null;
            }

            if (csModelKind.Equals(MuskingumModelDefine.M_KIND) == true)
            {
                var prop = new McCellModelPropertyInfo(csLibraryID, csModelKind);

                prop.SetStepTime(3600); // deltaT設定

                prop.SetInfo("m_lArrayNum", 100);

                prop.AddInfoType("m_CoefK", Properties.Resources.STRING_COEF_K_WITH_UOM, McDefine.ValKind.DOUBLE);
                prop.SetInfo("m_CoefK", 1.0);
                prop.AddInfoType("m_CoefX", Properties.Resources.STRING_COEF_X, McDefine.ValKind.DOUBLE);
                prop.SetInfo("m_CoefX", 0.2);

                // 受信パターンの設定 第１パターン, スカラ, 流量 m3/s
                var ports = prop.CreateTranInforPattern(
                    MuskingumModelDefine.IN_DISCHARGE_POINT_PTN,
                    McTranInfoDefine.SINGLE_CELL_SERIAL,
                    Properties.Resources.STRING_DISCHARGE_WITH_UOM) as McTranInfoPattern;
                {
                    // セル内変数設定
                    var cellVar = ports.CreateCellDataCharacteristic(1);
                    {
                        cellVar.SetDataKind(0, Properties.Resources.STRING_DISCHARGE,
                        HySDataKindDefine.QUANTITY_OF_WATER_FLOW, Properties.Resources.STRING_UOM_M3_PER_S);
                    }
                    ports.SetCellDataCharacteristic(cellVar);
                    ports.SetInterpolateType(HySDefine.InterpolateType.GET_NEXT_DATA); // 内挿方法設定
                }
                prop.AddReceivePattern(ports); // 受信パターンの追加


                // 受信パターンの設定 第2パターン, 1次元, 流量 m3/s
                ports = prop.CreateTranInforPattern(
                    MuskingumModelDefine.IN_DISCHARGE_1D_PTN,
                    McTranInfoDefine.D1_CELL_SERIAL,
                    Properties.Resources.STRING_DISCHARGE_WITH_UOM) as McTranInfoPattern;
                {
                    // セル内変数設定
                    var cellVar = ports.CreateCellDataCharacteristic(1);
                    {
                        cellVar.SetDataKind(0, Properties.Resources.STRING_DISCHARGE,
                        HySDataKindDefine.QUANTITY_OF_WATER_FLOW, Properties.Resources.STRING_UOM_M3_PER_S);
                    }
                    ports.SetCellDataCharacteristic(cellVar);
                    ports.SetInterpolateType(HySDefine.InterpolateType.GET_NEXT_DATA); // 内挿方法設定
                }
                prop.AddReceivePattern(ports); // 受信パターンの追加

                // 送信パターンの設定 第1パターン, スカラ, 流量 m3/s
                ports = prop.CreateTranInforPattern(
                      MuskingumModelDefine.OUT_DISCHARGE_POINT_PTN,
                      McTranInfoDefine.SINGLE_CELL_SERIAL,
                      Properties.Resources.STRING_DISCHARGE_WITH_UOM) as McTranInfoPattern;
                {
                    // セル内変数設定
                    var cellVar = ports.CreateCellDataCharacteristic(1);
                    {
                        cellVar.SetDataKind(0, Properties.Resources.STRING_DISCHARGE,
                        HySDataKindDefine.QUANTITY_OF_WATER_FLOW, Properties.Resources.STRING_UOM_M3_PER_S);
                    }
                    ports.SetCellDataCharacteristic(cellVar);
                }
                prop.AddSendPattern(ports);// 送信パターンの追加

                // 送信パターンの設定 第2パターン, 1次元, 流量 m3/s
                ports = prop.CreateTranInforPattern(
                    MuskingumModelDefine.OUT_DISCHARGE_1D_PTN,
                    McTranInfoDefine.D1_CELL_SERIAL,
                    Properties.Resources.STRING_DISCHARGE_WITH_UOM) as McTranInfoPattern;
                {
                    // セル内変数設定
                    var cellVar = ports.CreateCellDataCharacteristic(1);
                    {
                        cellVar.SetDataKind(0, Properties.Resources.STRING_DISCHARGE,
                        HySDataKindDefine.QUANTITY_OF_WATER_FLOW, Properties.Resources.STRING_UOM_M3_PER_S);
                    }
                    ports.SetCellDataCharacteristic(cellVar);
                }
                prop.AddSendPattern(ports); // 送信パターンの追加

                // 送信パターンの設定 第3パターン, 1次元, 内部情報
                ports = prop.CreateTranInforPattern(
                    MuskingumModelDefine.OUT_MODEL_STATE_1D_PTN,
                    McTranInfoDefine.D1_CELL_SERIAL,
                    Properties.Resources.STRING_MODEL_STATE) as McTranInfoPattern;
                {
                    // セル内変数設定
                    var cellVar = ports.CreateCellDataCharacteristic(1);
                    {
                        cellVar.SetDataKind(0, Properties.Resources.STRING_MODEL_STATE,
                        HySDataKindDefine.QUANTITY_OF_WATER_FLOW, Properties.Resources.STRING_UOM_NONE);
                    }
                    ports.SetCellDataCharacteristic(cellVar);
                }
                prop.AddSendPattern(ports); // 送信パターンの追加
                
                return prop;
            }
            else
            {
                return null;
            }
            
        }

        /// <summary><para>method outline:</para>
        /// <para>モデル初期化表示／設定情報生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McPropertyInfoRoot csInitialInf = CreateModelInitialInfo(csLibraryID, csModelKind ) </para>
        /// </example>
        /// <param name="csLibraryID">ライブラリー識別子</param>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>初期情報情報クラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McPropertyInfoRoot CreateModelInitialInfo(HySID csLibraryID, HySObjectKind csModelKind)
        {
            if (this.EqualFactory(csLibraryID) && csModelKind.Equals(MuskingumModelDefine.M_KIND) == true)
            {
                var init = new McInitialInfo(csLibraryID, csModelKind);

                //タイムステップ設定を消す
                init.RemoveStepTime();

                init.AddInfoType("m_InitStorage", Properties.Resources.STRING_STORAGE_INIT_WITH_UOM, McDefine.ValKind.DOUBLE);
                init.SetInfo("m_InitStorage", 0.0);
                return init;
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// <para>method outline:</para>
        /// <para>モデル情報提供</para>
        /// </summary>
        /// <example>
        /// <para>usage:</para>
        /// <para>HySDataLinkedList csModelInfoList = GetCalModelInfoList();</para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>モデル情報のリスト</returns>
        /// <exception cref="">無し</exception>
        /// <remarks>
        /// <para>remarks:</para>
        /// <para>モデル情報(McModelInfo)をリスト形式で返却する</para>
        /// </remarks>
        public override HySDataLinkedList GetCalModelInfoList()
        {
            var csModelInfo = new McModelInfo(
                    (HySID)this.GetFactoryID(),
                    McModelLibraryDefine.DIVISION_CALCULATION_MODEL,    // <-- 演算モデルは、必ずこの値にして下さい（LibraryCategoryXML.xmlに記述されている）
                    new HySObjectKind("CAL_RIVER_MODELS"), // <-- LibraryCategoryXML.xmlに定義されている値を使用する
                    MuskingumModelDefine.M_KIND, // モデルの識別子
                    MuskingumModelDefine.M_NAME  // モデルの名称
                                          );
            csModelInfo.SetVersionInf(Properties.Resources.STRING_MODEL_VERSION);
            csModelInfo.SetSummaryInf(Properties.Resources.STRING_MODEL_SUMMARY);
            csModelInfo.SetCreatorInf(Properties.Resources.STRING_MODEL_CREATOR);
            csModelInfo.SetIconName(@"jp.or.jccajsce.MuskingumModel_Factory\jp.or.jccajsce.MuskingumModel");
            csModelInfo.SetManualFileName(@"jp.or.jccajsce.MuskingumModel_Factory\jp.or.jccajsce.MuskingumModel.pdf");
            m_csCalModelInforList.AddLast(csModelInfo); // 演算モデル情報の追加
            return m_csCalModelInforList;
        }

    }
}
